<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'SuministroInformacion' => '\\StructType\\SuministroInformacion',
            'SuministroInformacionBaja' => '\\StructType\\SuministroInformacionBaja',
            'ConsultaInformacion' => '\\StructType\\ConsultaInformacion',
            'CabeceraSii' => '\\StructType\\CabeceraSii',
            'CabeceraSiiBaja' => '\\StructType\\CabeceraSiiBaja',
            'DatosPresentacionType' => '\\StructType\\DatosPresentacionType',
            'CabeceraConsultaSii' => '\\StructType\\CabeceraConsultaSii',
            'RegistroSii' => '\\StructType\\RegistroSii',
            'PeriodoImpositivo' => '\\StructType\\PeriodoImpositivo',
            'OperacionIntracomunitariaType' => '\\StructType\\OperacionIntracomunitariaType',
            'BienDeInversionType' => '\\StructType\\BienDeInversionType',
            'IDFacturaComunitariaType' => '\\StructType\\IDFacturaComunitariaType',
            'IDEmisorFactura' => '\\StructType\\IDEmisorFactura',
            'IDFacturaExpedidaBCType' => '\\StructType\\IDFacturaExpedidaBCType',
            'IDFacturaExpedidaType' => '\\StructType\\IDFacturaExpedidaType',
            'IDFacturaRecibidaType' => '\\StructType\\IDFacturaRecibidaType',
            'IDFacturaRecibidaNombreType' => '\\StructType\\IDFacturaRecibidaNombreType',
            'IDFacturaRecibidaNombreBCType' => '\\StructType\\IDFacturaRecibidaNombreBCType',
            'IDFacturaARType' => '\\StructType\\IDFacturaARType',
            'FacturaType' => '\\StructType\\FacturaType',
            'FacturasAgrupadas' => '\\StructType\\FacturasAgrupadas',
            'FacturasRectificadas' => '\\StructType\\FacturasRectificadas',
            'FacturaExpedidaType' => '\\StructType\\FacturaExpedidaType',
            'DatosInmueble' => '\\StructType\\DatosInmueble',
            'TipoDesglose' => '\\StructType\\TipoDesglose',
            'NoExentaRecibidasType' => '\\StructType\\NoExentaRecibidasType',
            'DesgloseIVA' => '\\StructType\\DesgloseIVA',
            'FacturaRecibidaType' => '\\StructType\\FacturaRecibidaType',
            'CobrosType' => '\\StructType\\CobrosType',
            'PagosType' => '\\StructType\\PagosType',
            'DetalleIVAEmitidaType' => '\\StructType\\DetalleIVAEmitidaType',
            'DetalleIVAEmitidaPrestacionType' => '\\StructType\\DetalleIVAEmitidaPrestacionType',
            'DetalleIVARecibidaType' => '\\StructType\\DetalleIVARecibidaType',
            'DesgloseRectificacionType' => '\\StructType\\DesgloseRectificacionType',
            'AduanasType' => '\\StructType\\AduanasType',
            'DatosInmuebleType' => '\\StructType\\DatosInmuebleType',
            'DatosPagoCobroType' => '\\StructType\\DatosPagoCobroType',
            'PersonaFisicaJuridicaESType' => '\\StructType\\PersonaFisicaJuridicaESType',
            'PersonaFisicaJuridicaUnicaESType' => '\\StructType\\PersonaFisicaJuridicaUnicaESType',
            'PersonaFisicaJuridicaType' => '\\StructType\\PersonaFisicaJuridicaType',
            'IDOtroType' => '\\StructType\\IDOtroType',
            'TipoConDesgloseType' => '\\StructType\\TipoConDesgloseType',
            'TipoSinDesgloseType' => '\\StructType\\TipoSinDesgloseType',
            'TipoSinDesglosePrestacionType' => '\\StructType\\TipoSinDesglosePrestacionType',
            'NoSujetaType' => '\\StructType\\NoSujetaType',
            'SujetaType' => '\\StructType\\SujetaType',
            'Exenta' => '\\StructType\\Exenta',
            'NoExenta' => '\\StructType\\NoExenta',
            'SujetaPrestacionType' => '\\StructType\\SujetaPrestacionType',
            'SuministroLRFacturasEmitidas' => '\\StructType\\SuministroLRFacturasEmitidas',
            'LRfacturasEmitidasType' => '\\StructType\\LRfacturasEmitidasType',
            'BajaLRFacturasEmitidas' => '\\StructType\\BajaLRFacturasEmitidas',
            'LRBajaExpedidasType' => '\\StructType\\LRBajaExpedidasType',
            'SuministroLRFacturasRecibidas' => '\\StructType\\SuministroLRFacturasRecibidas',
            'LRFacturasRecibidasType' => '\\StructType\\LRFacturasRecibidasType',
            'BajaLRFacturasRecibidas' => '\\StructType\\BajaLRFacturasRecibidas',
            'LRBajaRecibidasType' => '\\StructType\\LRBajaRecibidasType',
            'SuministroLRBienesInversion' => '\\StructType\\SuministroLRBienesInversion',
            'LRBienesInversionType' => '\\StructType\\LRBienesInversionType',
            'BajaLRBienesInversion' => '\\StructType\\BajaLRBienesInversion',
            'LRBajaBienesInversionType' => '\\StructType\\LRBajaBienesInversionType',
            'SuministroLRCobrosMetalico' => '\\StructType\\SuministroLRCobrosMetalico',
            'LRCobrosMetalicoType' => '\\StructType\\LRCobrosMetalicoType',
            'BajaLRCobrosMetalico' => '\\StructType\\BajaLRCobrosMetalico',
            'LRBajaCobrosMetalicoType' => '\\StructType\\LRBajaCobrosMetalicoType',
            'SuministroLRDetOperacionIntracomunitaria' => '\\StructType\\SuministroLRDetOperacionIntracomunitaria',
            'LROperacionIntracomunitariaType' => '\\StructType\\LROperacionIntracomunitariaType',
            'BajaLRDetOperacionIntracomunitaria' => '\\StructType\\BajaLRDetOperacionIntracomunitaria',
            'LRBajaOperacionIntracomunitariaType' => '\\StructType\\LRBajaOperacionIntracomunitariaType',
            'SuministroLRCobrosEmitidas' => '\\StructType\\SuministroLRCobrosEmitidas',
            'LRCobrosEmitidasType' => '\\StructType\\LRCobrosEmitidasType',
            'SuministroLRPagosRecibidas' => '\\StructType\\SuministroLRPagosRecibidas',
            'LRPagosEmitidasType' => '\\StructType\\LRPagosEmitidasType',
            'LRFiltroEmitidasType' => '\\StructType\\LRFiltroEmitidasType',
            'LRFiltroRecibidasType' => '\\StructType\\LRFiltroRecibidasType',
            'LRFiltroBienInversionType' => '\\StructType\\LRFiltroBienInversionType',
            'LRFiltroDetOperIntracomunitariasType' => '\\StructType\\LRFiltroDetOperIntracomunitariasType',
            'LRFiltroCobrosMetalicoType' => '\\StructType\\LRFiltroCobrosMetalicoType',
            'ClavePaginacion' => '\\StructType\\ClavePaginacion',
            'LRFiltroCobrosType' => '\\StructType\\LRFiltroCobrosType',
            'LRFiltroPagosType' => '\\StructType\\LRFiltroPagosType',
            'LRConsultaRecibidasType' => '\\StructType\\LRConsultaRecibidasType',
            'LRConsultaEmitidasType' => '\\StructType\\LRConsultaEmitidasType',
            'LRConsultaBienesInversionType' => '\\StructType\\LRConsultaBienesInversionType',
            'LRConsultaDetOperIntracomunitariasType' => '\\StructType\\LRConsultaDetOperIntracomunitariasType',
            'LRConsultaCobrosMetalicoType' => '\\StructType\\LRConsultaCobrosMetalicoType',
            'ConsultaCobrosType' => '\\StructType\\ConsultaCobrosType',
            'ConsultaPagosType' => '\\StructType\\ConsultaPagosType',
            'RespuestaConsultaLRFacturasEmitidasType' => '\\StructType\\RespuestaConsultaLRFacturasEmitidasType',
            'RespuestaConsultaLRFacturasRecibidasType' => '\\StructType\\RespuestaConsultaLRFacturasRecibidasType',
            'RespuestaConsultaLRBienesInversionType' => '\\StructType\\RespuestaConsultaLRBienesInversionType',
            'RespuestaConsultaLRDetOperIntracomunitariasType' => '\\StructType\\RespuestaConsultaLRDetOperIntracomunitariasType',
            'RespuestaConsultaLRCobrosMetalicoType' => '\\StructType\\RespuestaConsultaLRCobrosMetalicoType',
            'RespuestaConsultaCobrosType' => '\\StructType\\RespuestaConsultaCobrosType',
            'RespuestaConsultaPagosType' => '\\StructType\\RespuestaConsultaPagosType',
            'TitularPeriodoType' => '\\StructType\\TitularPeriodoType',
            'EstadoFacturaType' => '\\StructType\\EstadoFacturaType',
            'RegistroRespuestaConsultaEmitidasType' => '\\StructType\\RegistroRespuestaConsultaEmitidasType',
            'RegistroRespuestaConsultaRecibidasType' => '\\StructType\\RegistroRespuestaConsultaRecibidasType',
            'RegistroRespuestaConsultaBienesType' => '\\StructType\\RegistroRespuestaConsultaBienesType',
            'RegistroRespuestaConsultaDetOperIntracomunitariasType' => '\\StructType\\RegistroRespuestaConsultaDetOperIntracomunitariasType',
            'RegistroRespuestaConsultaCobrosMetalicoType' => '\\StructType\\RegistroRespuestaConsultaCobrosMetalicoType',
            'RegistroRespuestaConsultaCobrosType' => '\\StructType\\RegistroRespuestaConsultaCobrosType',
            'RegistroRespuestaConsultaPagosType' => '\\StructType\\RegistroRespuestaConsultaPagosType',
            'RespuestaDetOperIntracomunitariaType' => '\\StructType\\RespuestaDetOperIntracomunitariaType',
            'RespuestaCobrosMetalicoType' => '\\StructType\\RespuestaCobrosMetalicoType',
            'RespuestaConsultaLRFacturasType' => '\\StructType\\RespuestaConsultaLRFacturasType',
            'RespuestaConsultaFacturaCobrosType' => '\\StructType\\RespuestaConsultaFacturaCobrosType',
            'RespuestaConsultaFacturaPagosType' => '\\StructType\\RespuestaConsultaFacturaPagosType',
            'FacturaRespuestaType' => '\\StructType\\FacturaRespuestaType',
            'FacturaRespuestaExpedidaType' => '\\StructType\\FacturaRespuestaExpedidaType',
            'FacturaRespuestaRecibidaType' => '\\StructType\\FacturaRespuestaRecibidaType',
            'RespuestaComunAltaType' => '\\StructType\\RespuestaComunAltaType',
            'RespuestaLRFEmitidasType' => '\\StructType\\RespuestaLRFEmitidasType',
            'RespuestaLRFRecibidasType' => '\\StructType\\RespuestaLRFRecibidasType',
            'RespuestaLRBajaFRecibidasPagosType' => '\\StructType\\RespuestaLRBajaFRecibidasPagosType',
            'RespuestaLRBienesInversionType' => '\\StructType\\RespuestaLRBienesInversionType',
            'RespuestaLROComunitariasType' => '\\StructType\\RespuestaLROComunitariasType',
            'RespuestaLRIMetalicoType' => '\\StructType\\RespuestaLRIMetalicoType',
            'RespuestaComunBajaType' => '\\StructType\\RespuestaComunBajaType',
            'RespuestaLRBajaFEmitidasType' => '\\StructType\\RespuestaLRBajaFEmitidasType',
            'RespuestaLRBajaFRecibidasType' => '\\StructType\\RespuestaLRBajaFRecibidasType',
            'RespuestaLRBajaBienesInversionType' => '\\StructType\\RespuestaLRBajaBienesInversionType',
            'RespuestaLRBajaOComunitariasType' => '\\StructType\\RespuestaLRBajaOComunitariasType',
            'RespuestaLRBajaIMetalicoType' => '\\StructType\\RespuestaLRBajaIMetalicoType',
            'RespuestaExpedidaType' => '\\StructType\\RespuestaExpedidaType',
            'RespuestaRecibidaType' => '\\StructType\\RespuestaRecibidaType',
            'RespuestaRecibidaBajaType' => '\\StructType\\RespuestaRecibidaBajaType',
            'RespuestaRecibidaPagoType' => '\\StructType\\RespuestaRecibidaPagoType',
            'RespuestaBienType' => '\\StructType\\RespuestaBienType',
            'RespuestaComunitariaType' => '\\StructType\\RespuestaComunitariaType',
            'RespuestaMetalicoType' => '\\StructType\\RespuestaMetalicoType',
        );
    }
}
