<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CobrosType StructType
 * @subpackage Structs
 */
class CobrosType extends AbstractStructBase
{
    /**
     * The Cobro
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\DatosPagoCobroType[]
     */
    public $Cobro;
    /**
     * Constructor method for CobrosType
     * @uses CobrosType::setCobro()
     * @param \StructType\DatosPagoCobroType[] $cobro
     */
    public function __construct(array $cobro = array())
    {
        $this
            ->setCobro($cobro);
    }
    /**
     * Get Cobro value
     * @return \StructType\DatosPagoCobroType[]|null
     */
    public function getCobro()
    {
        return $this->Cobro;
    }
    /**
     * Set Cobro value
     * @throws \InvalidArgumentException
     * @param \StructType\DatosPagoCobroType[] $cobro
     * @return \StructType\CobrosType
     */
    public function setCobro(array $cobro = array())
    {
        foreach ($cobro as $cobrosTypeCobroItem) {
            // validation for constraint: itemType
            if (!$cobrosTypeCobroItem instanceof \StructType\DatosPagoCobroType) {
                throw new \InvalidArgumentException(sprintf('The Cobro property can only contain items of \StructType\DatosPagoCobroType, "%s" given', is_object($cobrosTypeCobroItem) ? get_class($cobrosTypeCobroItem) : gettype($cobrosTypeCobroItem)), __LINE__);
            }
        }
        $this->Cobro = $cobro;
        return $this;
    }
    /**
     * Add item to Cobro value
     * @throws \InvalidArgumentException
     * @param \StructType\DatosPagoCobroType $item
     * @return \StructType\CobrosType
     */
    public function addToCobro(\StructType\DatosPagoCobroType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DatosPagoCobroType) {
            throw new \InvalidArgumentException(sprintf('The Cobro property can only contain items of \StructType\DatosPagoCobroType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Cobro[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CobrosType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
