<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FacturasRectificadas StructType
 * Meta informations extracted from the WSDL
 * - documentation: El ID de las facturas rectificadas, únicamente se rellena en el caso de rectificación de facturas | El ID de las facturas rectificadas, únicamente se rellena en el caso de rectificación de facturas
 * @subpackage Structs
 */
class FacturasRectificadas extends AbstractStructBase
{
    /**
     * The IDFacturaRectificada
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\IDFacturaARType[]
     */
    public $IDFacturaRectificada;
    /**
     * Constructor method for FacturasRectificadas
     * @uses FacturasRectificadas::setIDFacturaRectificada()
     * @param \StructType\IDFacturaARType[] $iDFacturaRectificada
     */
    public function __construct(array $iDFacturaRectificada = array())
    {
        $this
            ->setIDFacturaRectificada($iDFacturaRectificada);
    }
    /**
     * Get IDFacturaRectificada value
     * @return \StructType\IDFacturaARType[]|null
     */
    public function getIDFacturaRectificada()
    {
        return $this->IDFacturaRectificada;
    }
    /**
     * Set IDFacturaRectificada value
     * @throws \InvalidArgumentException
     * @param \StructType\IDFacturaARType[] $iDFacturaRectificada
     * @return \StructType\FacturasRectificadas
     */
    public function setIDFacturaRectificada(array $iDFacturaRectificada = array())
    {
        foreach ($iDFacturaRectificada as $facturasRectificadasIDFacturaRectificadaItem) {
            // validation for constraint: itemType
            if (!$facturasRectificadasIDFacturaRectificadaItem instanceof \StructType\IDFacturaARType) {
                throw new \InvalidArgumentException(sprintf('The IDFacturaRectificada property can only contain items of \StructType\IDFacturaARType, "%s" given', is_object($facturasRectificadasIDFacturaRectificadaItem) ? get_class($facturasRectificadasIDFacturaRectificadaItem) : gettype($facturasRectificadasIDFacturaRectificadaItem)), __LINE__);
            }
        }
        $this->IDFacturaRectificada = $iDFacturaRectificada;
        return $this;
    }
    /**
     * Add item to IDFacturaRectificada value
     * @throws \InvalidArgumentException
     * @param \StructType\IDFacturaARType $item
     * @return \StructType\FacturasRectificadas
     */
    public function addToIDFacturaRectificada(\StructType\IDFacturaARType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\IDFacturaARType) {
            throw new \InvalidArgumentException(sprintf('The IDFacturaRectificada property can only contain items of \StructType\IDFacturaARType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->IDFacturaRectificada[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\FacturasRectificadas
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
