<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LRBienesInversionType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Datos correspondientes al libro de Bienes de inversión
 * @subpackage Structs
 */
class LRBienesInversionType extends RegistroSii
{
    /**
     * The IDFactura
     * @var \StructType\IDFacturaComunitariaType
     */
    public $IDFactura;
    /**
     * The BienesInversion
     * Meta informations extracted from the WSDL
     * - documentation: Apunte correspondiente al libro de bienes de inversion.
     * @var \StructType\BienDeInversionType
     */
    public $BienesInversion;
    /**
     * Constructor method for LRBienesInversionType
     * @uses LRBienesInversionType::setIDFactura()
     * @uses LRBienesInversionType::setBienesInversion()
     * @param \StructType\IDFacturaComunitariaType $iDFactura
     * @param \StructType\BienDeInversionType $bienesInversion
     */
    public function __construct(\StructType\IDFacturaComunitariaType $iDFactura = null, \StructType\BienDeInversionType $bienesInversion = null)
    {
        $this
            ->setIDFactura($iDFactura)
            ->setBienesInversion($bienesInversion);
    }
    /**
     * Get IDFactura value
     * @return \StructType\IDFacturaComunitariaType|null
     */
    public function getIDFactura()
    {
        return $this->IDFactura;
    }
    /**
     * Set IDFactura value
     * @param \StructType\IDFacturaComunitariaType $iDFactura
     * @return \StructType\LRBienesInversionType
     */
    public function setIDFactura(\StructType\IDFacturaComunitariaType $iDFactura = null)
    {
        $this->IDFactura = $iDFactura;
        return $this;
    }
    /**
     * Get BienesInversion value
     * @return \StructType\BienDeInversionType|null
     */
    public function getBienesInversion()
    {
        return $this->BienesInversion;
    }
    /**
     * Set BienesInversion value
     * @param \StructType\BienDeInversionType $bienesInversion
     * @return \StructType\LRBienesInversionType
     */
    public function setBienesInversion(\StructType\BienDeInversionType $bienesInversion = null)
    {
        $this->BienesInversion = $bienesInversion;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\LRBienesInversionType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
