<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RespuestaConsultaPagosType StructType
 * @subpackage Structs
 */
class RespuestaConsultaPagosType extends RespuestaConsultaFacturaPagosType
{
    /**
     * The RegistroRespuestaConsultaPagos
     * Meta informations extracted from the WSDL
     * - maxOccurs: 10000
     * - minOccurs: 0
     * @var \StructType\RegistroRespuestaConsultaPagosType[]
     */
    public $RegistroRespuestaConsultaPagos;
    /**
     * The ClavePaginacion
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var float
     */
    public $ClavePaginacion;
    /**
     * Constructor method for RespuestaConsultaPagosType
     * @uses RespuestaConsultaPagosType::setRegistroRespuestaConsultaPagos()
     * @uses RespuestaConsultaPagosType::setClavePaginacion()
     * @param \StructType\RegistroRespuestaConsultaPagosType[] $registroRespuestaConsultaPagos
     * @param float $clavePaginacion
     */
    public function __construct(array $registroRespuestaConsultaPagos = array(), $clavePaginacion = null)
    {
        $this
            ->setRegistroRespuestaConsultaPagos($registroRespuestaConsultaPagos)
            ->setClavePaginacion($clavePaginacion);
    }
    /**
     * Get RegistroRespuestaConsultaPagos value
     * @return \StructType\RegistroRespuestaConsultaPagosType[]|null
     */
    public function getRegistroRespuestaConsultaPagos()
    {
        return $this->RegistroRespuestaConsultaPagos;
    }
    /**
     * Set RegistroRespuestaConsultaPagos value
     * @throws \InvalidArgumentException
     * @param \StructType\RegistroRespuestaConsultaPagosType[] $registroRespuestaConsultaPagos
     * @return \StructType\RespuestaConsultaPagosType
     */
    public function setRegistroRespuestaConsultaPagos(array $registroRespuestaConsultaPagos = array())
    {
        foreach ($registroRespuestaConsultaPagos as $respuestaConsultaPagosTypeRegistroRespuestaConsultaPagosItem) {
            // validation for constraint: itemType
            if (!$respuestaConsultaPagosTypeRegistroRespuestaConsultaPagosItem instanceof \StructType\RegistroRespuestaConsultaPagosType) {
                throw new \InvalidArgumentException(sprintf('The RegistroRespuestaConsultaPagos property can only contain items of \StructType\RegistroRespuestaConsultaPagosType, "%s" given', is_object($respuestaConsultaPagosTypeRegistroRespuestaConsultaPagosItem) ? get_class($respuestaConsultaPagosTypeRegistroRespuestaConsultaPagosItem) : gettype($respuestaConsultaPagosTypeRegistroRespuestaConsultaPagosItem)), __LINE__);
            }
        }
        $this->RegistroRespuestaConsultaPagos = $registroRespuestaConsultaPagos;
        return $this;
    }
    /**
     * Add item to RegistroRespuestaConsultaPagos value
     * @throws \InvalidArgumentException
     * @param \StructType\RegistroRespuestaConsultaPagosType $item
     * @return \StructType\RespuestaConsultaPagosType
     */
    public function addToRegistroRespuestaConsultaPagos(\StructType\RegistroRespuestaConsultaPagosType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RegistroRespuestaConsultaPagosType) {
            throw new \InvalidArgumentException(sprintf('The RegistroRespuestaConsultaPagos property can only contain items of \StructType\RegistroRespuestaConsultaPagosType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RegistroRespuestaConsultaPagos[] = $item;
        return $this;
    }
    /**
     * Get ClavePaginacion value
     * @return float|null
     */
    public function getClavePaginacion()
    {
        return $this->ClavePaginacion;
    }
    /**
     * Set ClavePaginacion value
     * @param float $clavePaginacion
     * @return \StructType\RespuestaConsultaPagosType
     */
    public function setClavePaginacion($clavePaginacion = null)
    {
        $this->ClavePaginacion = $clavePaginacion;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RespuestaConsultaPagosType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
