<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SuministroLRPagosRecibidas StructType
 * Meta informations extracted from the WSDL
 * - documentation: Suministro de información de Pagos sobre el libro de registro de facturas recibidas
 * @subpackage Structs
 */
class SuministroLRPagosRecibidas extends SuministroInformacionBaja
{
    /**
     * The RegistroLRPagos
     * Meta informations extracted from the WSDL
     * - maxOccurs: 10000
     * @var \StructType\LRPagosEmitidasType[]
     */
    public $RegistroLRPagos;
    /**
     * Constructor method for SuministroLRPagosRecibidas
     * @uses SuministroLRPagosRecibidas::setRegistroLRPagos()
     * @param \StructType\LRPagosEmitidasType[] $registroLRPagos
     */
    public function __construct(array $registroLRPagos = array())
    {
        $this
            ->setRegistroLRPagos($registroLRPagos);
    }
    /**
     * Get RegistroLRPagos value
     * @return \StructType\LRPagosEmitidasType[]|null
     */
    public function getRegistroLRPagos()
    {
        return $this->RegistroLRPagos;
    }
    /**
     * Set RegistroLRPagos value
     * @throws \InvalidArgumentException
     * @param \StructType\LRPagosEmitidasType[] $registroLRPagos
     * @return \StructType\SuministroLRPagosRecibidas
     */
    public function setRegistroLRPagos(array $registroLRPagos = array())
    {
        foreach ($registroLRPagos as $suministroLRPagosRecibidasRegistroLRPagosItem) {
            // validation for constraint: itemType
            if (!$suministroLRPagosRecibidasRegistroLRPagosItem instanceof \StructType\LRPagosEmitidasType) {
                throw new \InvalidArgumentException(sprintf('The RegistroLRPagos property can only contain items of \StructType\LRPagosEmitidasType, "%s" given', is_object($suministroLRPagosRecibidasRegistroLRPagosItem) ? get_class($suministroLRPagosRecibidasRegistroLRPagosItem) : gettype($suministroLRPagosRecibidasRegistroLRPagosItem)), __LINE__);
            }
        }
        $this->RegistroLRPagos = $registroLRPagos;
        return $this;
    }
    /**
     * Add item to RegistroLRPagos value
     * @throws \InvalidArgumentException
     * @param \StructType\LRPagosEmitidasType $item
     * @return \StructType\SuministroLRPagosRecibidas
     */
    public function addToRegistroLRPagos(\StructType\LRPagosEmitidasType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LRPagosEmitidasType) {
            throw new \InvalidArgumentException(sprintf('The RegistroLRPagos property can only contain items of \StructType\LRPagosEmitidasType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RegistroLRPagos[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SuministroLRPagosRecibidas
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
